<?php
/*
 * MergeStudycourses.class.php - Merge studycourses - useful for upgrade from Stud.IP 1.x to 2.0 or merging two studycourses.
 * converts the database-entries for existing study-courses to another one. 
 * Copyright (c) 2011  Bernhard Strehl
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 */

require_once 'vendor/trails/trails.php';

class MergeStudycourses extends StudipPlugin implements AdministrationPlugin
{
    /**
     * Initialize a new instance of the plugin.
     */
    function __construct()
    {
        parent::__construct();

        global $perm;
        if(!$perm->have_perm('root'))
                return;
        // set up top navigation
        $top_nav = new Navigation('TrailsDemo');
        $top_nav->setImage($this->getPluginURL().'/images/icon.gif');

        // set up tab navigation
       
           $merge_nav = new Navigation(_('Studiengnge verschmelzen'), PluginEngine::getURL('mergestudycourses/showlist'));
        Navigation::addItem('/admin/plugins/mergestudycourses', $merge_nav);
    }

    /**
     * This method dispatches all actions.
     *
     * @param string   part of the dispatch path that was not consumed
     */
    function perform($unconsumed_path)
    {
        $trails_root = $this->getPluginPath();
        $dispatcher = new Trails_Dispatcher($trails_root, NULL, NULL);
        $dispatcher->dispatch($unconsumed_path);
    }
}
?>
