<?php

/*
 * showlist.php -
 * - show all studycourses
 * - show the selected studycourses
 * - save the changes
 * Copyright (c) 2011  Bernhard Strehl
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 */

require_once 'app/controllers/studip_controller.php';
require('app/models/studycourse.php');

class ShowlistController extends StudipController
{

    /**
     * Common code for all actions: set default layout and page title.
     */
    function before_filter(&$action, &$args)
    {
        $this->flash = Trails_Flash::instance();

        // set default layout
        $layout = $GLOBALS['template_factory']->open('layouts/base');
        $this->set_layout($layout);

        $GLOBALS['CURRENT_PAGE'] = 'Studiengangverschmelzung';
        Navigation::activateItem('/admin/plugins/mergestudycourses');
    }

    /**
     * This is the default action of this controller.
     */
    function index_action()
    {
        global $perm;
        $perm->check('root');


        $all_sc = StudycourseModel::getStudyCourses();



        $this->all_studycourses = $all_sc;

        if (isset($this->flash['message']))
        {
            $this->message = $this->flash['message'];
        }
    }

    /**
     * The button has been clicked: show a message.
     */
    function preview_action()
    {
        global $perm;
        $perm->check('root');

        $all_deg = StudycourseModel::getStudyDegrees();
        foreach ($_POST['merge_courses'] as $sc_id)
            $merge_sc_tmp[] = ( StudycourseModel::getStudyCourses($sc_id));

        //fix fuck upped behaviour
        foreach ($merge_sc_tmp as $dumbarray)
            $merge_sc[] = $dumbarray[0];
        $this->studydegrees = $all_deg;
        $this->merge_courses = $merge_sc;
    }

    function save_action()
    {

        global $perm;
        $perm->check('root');

        $course_to_keep = $_POST['keep'];
        if (!$course_to_keep)
        {
            $message = "Kein Studiengang zum Behalten ausgewhlt - abgebrochen.";
            $this->flash['message'] = $message;
            $this->redirect(PluginEngine::getURL('mergestudycourses/showlist'));
            return;
        }

        $db = DBManager::get();
        $delete_course_list = array();
        $sql_commands = array();
        foreach ($_POST['merge_courses'] as $oldcourse)
        {
            //Es geht um den Studiengang, der behalten werden soll
            if ($oldcourse == $course_to_keep)
            {
                //rename the course.. 
                if ($_POST['rename_course'])
                {
                    $newcourse_details = StudycourseModel::getStudyCourseInfo($course_to_keep);
                    StudycourseModel::saveEditProfession($course_to_keep, $_POST['rename_course_title'], $newcourse_details['beschreibung']);
                }
                //Fr den Fall, dass dem Studiengang-to-keep ein Abschluss zugeordnet werden soll 
                $book_degree = $_POST['book_studydegree'][$course_to_keep];
                if ($book_degree)
                    $sql_commands[] = 'update IGNORE user_studiengang set  abschluss_id="' . $book_degree . '" where studiengang_id="' . $course_to_keep . '" ';
            }
            //Die anderen Studiengnge, die gelscht werden 
            else
            {
                $delete_course_list[] = $oldcourse;


                //in der admission_seminar_user-tabelle eintrge mit den zu lschenden studiengngen ersetzen (gespeicherte Studiengnge fr Los o)
                $sql_commands[] = 'update admission_seminar_user set studiengang_id = "' . $course_to_keep . '" where studiengang_id="' . $oldcourse . '" ';
                //in der seminar_user-tabelle eintrge mit den zu lschenden studiengngen ersetzen ("teilnehmerkontingent in einer va")
                $sql_commands[] = 'update seminar_user set admission_studiengang_id  = "' . $course_to_keep . '"  where admission_studiengang_id="' . $oldcourse . '" ';


                //hat der admin einen Abschluss gewhlt, der zu dem Studiengang gebucht werden soll?
                $book_degree = $_POST['book_studydegree'][$oldcourse];

                //studiengnge eines benutzers update
                //ignore fr den fall, dass er in dem to-keep auch schon eingetragen ist, dann gbs ne constraint-verletzung
                if ($book_degree)
                    $sql_commands[] = 'update IGNORE user_studiengang set studiengang_id = "' . $course_to_keep . '", abschluss_id="' . $book_degree . '" where studiengang_id="' . $oldcourse . '" ';
                else
                    $sql_commands[] = 'update IGNORE user_studiengang set studiengang_id = "' . $course_to_keep . '"  where studiengang_id="' . $oldcourse . '" ';

                //Mglicherweise kams (s.o.) zu Unique-Constraint-Verletzungen - es werden somit Eintrge fr den alten Studiengang gekickt
                $sql_commands[] = 'delete from user_studiengang where studiengang_id="' . $oldcourse . '"';
            }
        }

        //jetzt mssen noch die studiengang-quotas  fr die einzelnen seminare neu berechnet und ersetzt werden
        $all_affected_seminars = $db->query('select seminar_id from admission_seminar_studiengang where studiengang_id in ("' . implode('","', $delete_course_list) . '")')->fetchAll(PDO::FETCH_COLUMN);

        foreach ($all_affected_seminars as $seminar_id)
        {
            //summe der quota aller studiengnge, die gemerged werden.
            // auch den to-keep, um die summe ALLER quota zu erhalten.
            $quota_counter = $db->query('SELECT sum( quota )
                                                FROM `admission_seminar_studiengang`
                                                WHERE seminar_id = "' . $seminar_id . '"
                                                AND `studiengang_id`
                                                IN ("' . implode('","', $_POST['merge_courses']) . '") ')->fetchColumn();

            //fhre die gerade erhaltenen quota dem verbleibenden Studiengang zu.
            //replace statt update falls dieser studiengang nicht in der quotaliste drin war.
            $newstd_gang_update_cmd = 'replace into  admission_seminar_studiengang (seminar_id, studiengang_id, quota) VALUES("' . $seminar_id . '","' . $course_to_keep . '","' . $quota_counter . '") ';

            //lsche die Eintrge fr die alten, zu lschenden Studiengnge
            $delete_old_command = 'delete from admission_seminar_studiengang where seminar_id="' . $seminar_id . '"  AND `studiengang_id`  IN ("' . implode('","', $delete_course_list) . '") ';

            $db->exec($newstd_gang_update_cmd);

            $db->exec($delete_old_command);
        }


        //Jetzt wirklich Daten ersetzen und lschen.
        foreach ($sql_commands as $sql)
        {
            //debug: an was haktsn?
            try
            {
                $db->exec($sql);
            } catch (Exception $e)
            {
                echo $sql;
                throw $e;
            }
        }
        // jetzt werden sie natrlich vernichtet
        foreach ($delete_course_list as $delc)
            StudycourseModel::deleteStudyCourse($delc);

        #   echo '<pre>';
        $msg = sprintf(_("Es wurden %s Studiengnge zusammengefhrt."), count($_POST['merge_courses']));
        $this->flash['message'] = MessageBox::success($msg);
        PageLayout::disableHeader();
        $this->redirect(PluginEngine::getURL('mergestudycourses/showlist'));
         
    }

}

?>
